<?php
/*
Plugin Name: PixoPoint Google Docs
Plugin URI: http://pixopoint.com/
Description: Allows users to embed Google Docs into their site
Author: PixoPoint
Version: 0.1
Author URI: http://pixopoint.com/
*/

/**
 * Google Docs [googledocs] shortcode
 * @since 0.1
 */
function pixopoint_google_docs_shortcode( $data ) {

	// Getting size data
	$size = $data['w'];
	str_replace( '&#038;h=', '&amp;h=', $size );
	$size = explode( '&amp;h=', $size );
	$w = $size[0];
	$h = $size[1];
	if ( !is_int( $w ) )
		$w = 600; // fallback if invalid width given
	if ( !is_int( $w ) )
		$h = 600; // fallback if invalid height given

	$url = $data[0]; // Grab URL
	$url = esc_url( $url ); // Sanitizing URL
	$url = pixopoint_google_doc_url_checker( $url );

	// Print reformed embed code on screen
	return '
<iframe src="' . $url . '" style="border: 0" width="' . $w . '" height="' . $h . '" frameborder="0" scrolling="no"></iframe>
';
}
add_shortcode( 'googledocs', 'pixopoint_google_docs_shortcode' );

/**
 * Checks URL sub-domain is in white list
 * @since 0.1
 */
function pixopoint_google_doc_url_checker( $url ) {

	// Create white list of sub-domains to trust
	$white_list = array(
		'https://docs.google.com/document/pub?id=',
		'https://spreadsheets.google.com/embedded',
		'https://spreadsheets.google.com/pub?key=',
		'https://docs.google.com/drawings/pub?id=',
		'https://docs.google.com/present/embed?id',
	);

	// Grab first 40 characters of URL and check they match something from the white list
	$chunk = substr( $url, 0, 40 );
	foreach ( $white_list as $opt ) {
		if ( $opt == $chunk )
			$safe_url = esc_url( $url ); // sanitizing rest of URL in case some miscreant injected something nasty in there
	}

	return $safe_url;
}

